;==============================================================================
;       Test Department's WINDOWS 32 BIT x86 ASSEMBLY example           852
;==============================================================================

My_HexDDtoStringDec:        ;don't forget to save register (pushad/popad)
;------------------------------------------------------------------------------
; Converts a 32 bit value in EAX into an ascii decimal string to offset EDI.
; Fast DWORD to decimal string conversion. Made by tE! // TMG.
;------------------------------------------------------------------------------
push    0h                  ;get some additional space on stack (10 bytes min.)
push    0h                  ;'' upper dword is 0
push    eax                 ;'' lower dword -> 32 bit integer to convert
fild    qword ptr[esp]      ;load 64 bit integer value on TOS
fbstp   real10 ptr[esp]     ; store value as 80bit BCD value
pop     ecx
pop     eax
mov     edx,ecx
mov     ebx,eax
shr     ecx,4
shr     eax,4
and     ebx,0000000Fh       ;mask nibbles
and     edx,0F0F0F0Fh       ;...
and     ecx,0F0F0F0Fh
add     edx,30303030h       ;build ascii numbers
add     ecx,30303030h       ;...
add     eax,30h
add     ebx,30h
mov     [edi],al            ;store in buffer
mov     [edi+1],bl          ;...
mov     [edi+8],cl
mov     [edi+9],dl
mov     [edi+6],ch
mov     [edi+7],dh
bswap   ecx                 ;endian conversion (486 processor needed)
bswap   edx                 ;dto.
mov     [edi+2],cl
mov     [edi+3],dl
mov     [edi+4],ch
mov     [edi+5],dh
pop     eax                 ;correct stack
ret